/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.AutobusDAO;
import com.rjconsultores.ventaboletos.entidad.Autobus;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.service.AutobusService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Administrador
 */
@Service("autobusService")
public class AutobusServiceImpl implements AutobusService {

    @Autowired
    private AutobusDAO autobusDAO;
    public List<Autobus> obtenerTodos() {
        return autobusDAO.obtenerTodos();
    }

    public Autobus obtenerID(Integer id) {
        return autobusDAO.obtenerID(id);
    }

    @Transactional
    public Autobus suscribir(Autobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return autobusDAO.suscribir(entidad);
    }

    @Transactional
    public Autobus actualizacion(Autobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return autobusDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Autobus entidad) {
        
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        autobusDAO.actualizacion(entidad);
    }

    public List<Autobus> buscar(String numautobus, DiagramaAutobus diagramaAutobus) {
        return autobusDAO.buscar(numautobus, diagramaAutobus);
    }
}
